--- sendmail-8.12.8/cf/m4/proto.m4	Mon Dec 30 10:46:02 2002
+++ sendmail-8.12.8-patched/cf/m4/proto.m4	Sun Mar  9 14:58:05 2003
@@ -1007,6 +1007,13 @@
 #
 
 SParse1
+
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+#Store rcpt to host for later usage when - the mail hub feature
+R$+ <  @ $+ >			$: $(macro {ORIG_HOST} $@ $2 $) $1 < @ $2 >',
+`dnl')
+
+
 ifdef(`_LDAP_ROUTING_', `dnl
 # handle LDAP routing for hosts in $={LDAPRoute}
 R$+ < @ $={LDAPRoute} . >	$: $>LDAPExpand <$1 < @ $2 . >> <$1 @ $2> <>
@@ -1235,10 +1242,16 @@
 ifdef(`_PRESERVE_LUSER_HOST_', `dnl
 dnl it is $~[ instead of $- to avoid matches on IPv6 addresses
 R< $~[ : $+ > $+ @ $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $4 >')
-R< $~[ : $+ > $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $2 >
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+R< $~[ : $+ > $+ @ $+	$: < $1 : $2 > $3 < @ $&{ORIG_HOST} >
+R< $+ > $+ < @ $+ >	$@ $>MailerToTriple < $1 > $2 < @ $3 >',`dnl
+R< $~[ : $+ > $+	$: $>MailerToTriple < $1 : $2 > $3 < @ $2 >')
 ifdef(`_PRESERVE_LUSER_HOST_', `dnl
 R< $+ > $+ @ $+		$@ $>MailerToTriple < $1 > $2 < @ $3 >')
-R< $+ > $+		$@ $>MailerToTriple < $1 > $2 < @ $1 >
+ifdef(`_PRESERVE_HOST_ON_LOCAL_',`dnl
+R< $+ > $+		$: < $1 > $2 < @ $&{ORIG_HOST} >
+R< $+ > $+ < @ $+ >	$@ $>MailerToTriple < $1 > $2 < @ $3 >',`dnl
+R< $+ > $+		$@ $>MailerToTriple < $1 > $2 < @ $1 >')
 
 ifdef(`_MAILER_TABLE_', `dnl
 ifdef(`_LDAP_ROUTING_', `dnl
